// PAYDAY The Heist v1 Header Extractor
// Extracts header files from the bundles so that they can be read by Bundle Modder/Diesel Toolbox
// Bad code courtesy of Zdann (https://steamcommunity.com/id/Zdann/)
// umu
import java.io.*;
import java.nio.ByteBuffer;
public class PDTHHeader {

	public static void main(String[] args) throws IOException {
		BufferedInputStream bundleStream = null;
		FileOutputStream headerStream = null;
		DataInputStream headerLengthStream = null;
		File folder = new File (".");
		File[] bundleList = folder.listFiles();
		
		for (int i = 0; i < bundleList.length; i++) {
			String bundleName = bundleList[i].getName();
			if (bundleList[i].isFile()) {
				if (isValidBundle(bundleName)) {
					bundleStream = new BufferedInputStream(new FileInputStream(bundleName));
					headerStream = new FileOutputStream(headerName(bundleName));
					headerLengthStream = new DataInputStream(bundleStream);
					
					System.out.println("Reading " + bundleName);
					
					bundleStream.mark(0);
					int headerLength = Integer.reverseBytes(headerLengthStream.readInt());	//Endian conversion, get header length
					byte[] headerData = ByteBuffer.allocate(headerLength + 4).putInt(headerLength).array();
					bundleStream.reset();
					bundleStream.read(headerData);
					headerStream.write(headerData);
					
					System.out.println("Wrote " + headerName(bundleName));
				}
				else
					System.out.println("Skipping " + bundleName);
			}
		}
		
		bundleStream.close();
		headerStream.close();
		headerLengthStream.close();
	}
	
	public static Boolean isValidBundle(String fileName) {
		if ((!fileName.contains("_h")) & (fileName.endsWith(".bundle")))
			return true;
		else
			return false;
	}
	
	public static String headerName(String filename) {
		int dot = filename.lastIndexOf('.');
		String headerName = filename.substring(0, dot) + "_h" + filename.substring(dot);
		return headerName;
	}
}